#!/usr/bin/perl -w
# cleansid.pl - a simple script to cleanup session file
# 
# Author: Chi-Keung Ho (He zhiqiang) <hzqbbc@hzqbbc.com>
use strict;
my $timeout = 24*60*60; # 24 hours
my $curtime = time;
my $dir = $ARGV[0];

die "$0 /path/to/session/dir\n" unless $dir;

opendir DIR, $dir or die "opendir: $!\n";
my @files = grep { /^sid_/ } readdir DIR;
close DIR;

for(@files) {
	my $t = (stat "$dir/$_")[9];
	if($curtime-$t>$timeout) {
		print "$_ has been deleted\n";
		unlink "$dir/$_";
	}else {
		print STDERR "$_ still alive\n";
	}
}
